import java.dyn.*;

public class Sample {
  public static void  foo() {
    System.out.println("FOO");
  }
  public static int dbl(int input) { return input * 2; }
}

class User {
  static {
    Linkage.registerBootstrapMethod("bootstrapMethod");
  }

  public static MethodHandle fooCaller = MethodHandles.lookup().findStatic(Sample.class, "foo", MethodType.methodType(void.class));
  public static MethodHandle dblCaller = MethodHandles.lookup().findStatic(Sample.class, "dbl", MethodType.methodType(Integer.TYPE, Integer.TYPE));

  public static CallSite bootstrapMethod(Class klass, String name, MethodType methodType) {
    System.out.println("******bootStrapMethod called... by " + klass + " with name " + name + " with MT " + methodType);
    MethodHandle target = null;
    switch(name) {
      case "woot" :
        target = MethodHandles.convertArguments(fooCaller, methodType);
        break;
      case "dblCaller" :
        target = MethodHandles.convertArguments(dblCaller, methodType);
        break;
    }
    CallSite callSite = new CallSite(klass, name, methodType);
    callSite.setTarget(target);
    return callSite;
  }

  public static void main(String[] args) throws Throwable {
    fooCaller.<void>invoke();
    System.out.println("Calling dynamic");
    InvokeDynamic.woot();
    InvokeDynamic.woot();
    System.out.println(InvokeDynamic.dblCaller(2));
  }
}
